"use strict";
/*
 * Copyright (c) 2018-2023, NeKz
 *
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserCmd = void 0;
class UserCmd {
    constructor() {
        Object.defineProperty(this, "commandNumber", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "tickCount", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "viewAngleX", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "viewAngleY", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "viewAngleZ", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "forwardMove", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "sideMove", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "upMove", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "buttons", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "impulse", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "weaponSelect", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "weaponSubtype", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "mouseDx", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "mouseDy", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
    }
    read(buf) {
        if (buf.readBoolean())
            this.commandNumber = buf.readInt32();
        if (buf.readBoolean())
            this.tickCount = buf.readInt32();
        if (buf.readBoolean())
            this.viewAngleX = buf.readFloat32();
        if (buf.readBoolean())
            this.viewAngleY = buf.readFloat32();
        if (buf.readBoolean())
            this.viewAngleZ = buf.readFloat32();
        if (buf.readBoolean())
            this.forwardMove = buf.readFloat32();
        if (buf.readBoolean())
            this.sideMove = buf.readFloat32();
        if (buf.readBoolean())
            this.upMove = buf.readFloat32();
        if (buf.readBoolean())
            this.buttons = buf.readInt32();
        if (buf.readBoolean())
            this.impulse = buf.readInt8();
        if (buf.readBoolean()) {
            this.weaponSelect = buf.readBits(11);
            if (buf.readBoolean())
                this.weaponSubtype = buf.readBits(6);
        }
        if (buf.readBoolean())
            this.mouseDx = buf.readInt16();
        if (buf.readBoolean())
            this.mouseDy = buf.readInt16();
    }
}
exports.UserCmd = UserCmd;
